org.apache.commons.io.input

## Class BOMInputStream.Builder

- java.lang.Object
- - org.apache.commons.io.build.AbstractSupplier<T,B>
  - - org.apache.commons.io.build.AbstractOriginSupplier<T,B>
    - - org.apache.commons.io.build.AbstractStreamBuilder<T,B>
      - - org.apache.commons.io.input.ProxyInputStream.AbstractBuilder<BOMInputStream,BOMInputStream.Builder>
        - - org.apache.commons.io.input.BOMInputStream.Builder

- All Implemented Interfaces:
    IOSupplier<BOMInputStream>
  Enclosing class:
    BOMInputStream

      public static class BOMInputStream.Builder
      extends ProxyInputStream.AbstractBuilder<BOMInputStream,BOMInputStream.Builder>

  Builds a new `BOMInputStream`.

  ## Using NIO

       BOMInputStream s = BOMInputStream.builder()
         .setPath(Paths.get("MyFile.xml"))
         .setByteOrderMarks(ByteOrderMark.UTF_8)
         .setInclude(false)
         .get();

  ## Using IO

       BOMInputStream s = BOMInputStream.builder()
         .setFile(new File("MyFile.xml"))
         .setByteOrderMarks(ByteOrderMark.UTF_8)
         .setInclude(false)
         .get();

  See Also:
    `get()`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Builder()` Constructs a new builder of `BOMInputStream`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `BOMInputStream` | `get()` Builds a new `BOMInputStream`.
    `(package private) static ByteOrderMark` | `getDefaultByteOrderMark()` For test access.
    `BOMInputStream.Builder` | `setByteOrderMarks(ByteOrderMark... byteOrderMarks)` Sets the ByteOrderMarks to detect and optionally exclude.
    `BOMInputStream.Builder` | `setInclude(boolean include)` Sets whether to include the UTF-8 BOM (true) or to exclude it (false).

    - ### Methods inherited from class org.apache.commons.io.input.ProxyInputStream.AbstractBuilder

      `getAfterRead, setAfterRead`

    - ### Methods inherited from class org.apache.commons.io.build.AbstractStreamBuilder

      `getBufferSize, getBufferSizeDefault, getCharSequence, getCharset, getCharsetDefault, getFile, getInputStream, getOpenOptions, getOutputStream, getPath, getRandomAccessFile, getReader, getWriter, setBufferSize, setBufferSize, setBufferSizeChecker, setBufferSizeDefault, setBufferSizeMax, setCharset, setCharset, setCharsetDefault, setOpenOptions`

    - ### Methods inherited from class org.apache.commons.io.build.AbstractOriginSupplier

      `checkOrigin, getOrigin, hasOrigin, newByteArrayOrigin, newCharSequenceOrigin, newFileOrigin, newFileOrigin, newInputStreamOrigin, newOutputStreamOrigin, newPathOrigin, newPathOrigin, newRandomAccessFileOrigin, newRandomAccessFileOrigin, newReaderOrigin, newURIOrigin, newWriterOrigin, setByteArray, setCharSequence, setFile, setFile, setInputStream, setOrigin, setOutputStream, setPath, setPath, setRandomAccessFile, setRandomAccessFile, setReader, setURI, setWriter`

    - ### Methods inherited from class org.apache.commons.io.build.AbstractSupplier

      `asThis`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.io.function.IOSupplier

      `asSupplier, getUnchecked`

- - ### Constructor Detail

    - #### Builder

          public Builder()

      Constructs a new builder of `BOMInputStream`.

  - ### Method Detail

    - #### get

          public BOMInputStream get()
                             throws IOException

      Builds a new `BOMInputStream`.

      You must set an aspect that supports `AbstractStreamBuilder.getInputStream()`, otherwise, this method throws an exception.

      This builder uses the following aspects: InputStream, OpenOption[], include, and ByteOrderMark[].

      This builder uses the following aspects:

      - `AbstractStreamBuilder.getInputStream()`
      - include}
      - byteOrderMarks
      Returns:
        a new instance.
      Throws:
        `IllegalStateException` - if the `origin` is `null`.
        `UnsupportedOperationException` - if the origin cannot be converted to an `InputStream`.
        `IOException` - if an I/O error occurs converting to an `InputStream` using `AbstractStreamBuilder.getInputStream()`.
      See Also:
        `AbstractStreamBuilder.getInputStream()`, `IOSupplier.getUnchecked()`

    - #### getDefaultByteOrderMark

          static ByteOrderMark getDefaultByteOrderMark()

      For test access.
      Returns:
        the default byte order mark

    - #### setByteOrderMarks

          public BOMInputStream.Builder setByteOrderMarks(ByteOrderMark... byteOrderMarks)

      Sets the ByteOrderMarks to detect and optionally exclude.

      The default is `ByteOrderMark.UTF_8`.

      Parameters:
        `byteOrderMarks` - the ByteOrderMarks to detect and optionally exclude.
      Returns:
        `this` instance.

    - #### setInclude

          public BOMInputStream.Builder setInclude(boolean include)

      Sets whether to include the UTF-8 BOM (true) or to exclude it (false).

      The default is false.

      Parameters:
        `include` - true to include the UTF-8 BOM or false to exclude it. return this;
      Returns:
        `this` instance.